#include <stdio.h>
#include <termios.h>
#include <unistd.h>
#include <stdlib.h>

#define PWM_IOCTL_SET_FREQ		1
#define PWM_IOCTL_STOP			2

#define	ESC_KEY		0x1b
#define MAX_NUM		10


void
change_pwm(int *pwm)
{
	char tmp[100];
	if( *pwm >MAX_NUM) *pwm =10;
	if( *pwm <0) *pwm = 0;
	sprintf(tmp, "echo %d > /sys/class/backlight/pwm-backlight.0/brightness", *pwm);
	system(tmp);
	printf("duty cycle ..%d\n ",*pwm);
}

static int
getch(void)
{
	struct termios oldt, newt;
	int ch;

	if (!isatty(STDIN_FILENO)) {
		fprintf(stderr, "this problem should be run at a terminal\n");
		exit(1);
	}
	// save terminal setting
	if (tcgetattr(STDIN_FILENO, &oldt) < 0) {
		perror("save the terminal setting");
		exit(1);
	}
	// set terminal as need
	newt = oldt;
	newt.c_lflag &= ~(ICANON | ECHO);
	if (tcsetattr(STDIN_FILENO, TCSANOW, &newt) < 0) {
		perror("set terminal");
		exit(1);
	}

	ch = getchar();

	// restore termial setting
	if (tcsetattr(STDIN_FILENO, TCSANOW, &oldt) < 0) {
		perror("restore the termial setting");
		exit(1);
	}
	return ch;
}

void
print_help()
{
	printf("press '+' to increase duty cycle\n");
	printf("press '-' to decrease duty cycle\n");
	printf("press 'ESC' ,to shutdown bezzer\n");

}

int
main(int argc, char **argv)
{
	
	int key;
	int pwm = 0;
	print_help();
	change_pwm(&pwm);
	while (1) {

		key = getch();

		switch (key) {
		case '+':
			pwm++;
			change_pwm(&pwm);
			break;

		case '-':
			pwm--;
			change_pwm(&pwm);
			break;

		case ESC_KEY:
		case EOF:
			system("echo 255 > /sys/class/backlight/pwm-backlight.0/brightness");
			exit(0);

		default:
			break;
		}
	}
}
