
/*
 * Copyright (C) Waveshare  Electronic Inc. All Rights Reserved.
 * for more information website http://www.waveshare.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */
#include <stdio.h>
#include <termios.h>
#include <unistd.h>
#include <stdlib.h>

#define PWM_IOCTL_SET_FREQ		1
#define PWM_IOCTL_STOP			2

#define	ESC_KEY		0x1b
#define MAX_NUM		256


void
change_pwm(int *pwm)
{
	char tmp[100];
	if( *pwm >MAX_NUM) *pwm =256;
	if( *pwm <0) *pwm = 0;
	sprintf(tmp, "echo %d > /sys/class/backlight/pwm-backlight.3/brightness", *pwm);
	system(tmp);
	printf("duty cycle ..%d\n ",*pwm);
}

static int
getch(void)
{
	struct termios oldt, newt;
	int ch;

	if (!isatty(STDIN_FILENO)) {
		fprintf(stderr, "this problem should be run at a terminal\n");
		exit(1);
	}
	// save terminal setting
	if (tcgetattr(STDIN_FILENO, &oldt) < 0) {
		perror("save the terminal setting");
		exit(1);
	}
	// set terminal as need
	newt = oldt;
	newt.c_lflag &= ~(ICANON | ECHO);
	if (tcsetattr(STDIN_FILENO, TCSANOW, &newt) < 0) {
		perror("set terminal");
		exit(1);
	}

	ch = getchar();

	// restore termial setting
	if (tcsetattr(STDIN_FILENO, TCSANOW, &oldt) < 0) {
		perror("restore the termial setting");
		exit(1);
	}
	return ch;
}

void
print_help()
{
	printf("press '+' to increase duty cycle\n");
	printf("press '-' to decrease duty cycle\n");
	printf("press 'ESC' ,to shutdown bezzer\n");

}

int
main(int argc, char **argv)
{
	
	int key;
	int pwm = 0;
	print_help();
	change_pwm(&pwm);
	while (1) {

		key = getch();

		switch (key) {
		case '+':
			pwm++;
			change_pwm(&pwm);
			break;

		case '-':
			pwm--;
			change_pwm(&pwm);
			break;

		case ESC_KEY:
		case EOF:
			system("echo 255 > /sys/class/backlight/pwm-backlight.0/brightness");
			exit(0);

		default:
			break;
		}
	}
}
